<template>
  <div style="min-height: 90vh">
    <v-alert class="hidden-screen-only" color="error" icon="warning" outlined>
      {{ $t("dcc.preview.printWarning") }}
    </v-alert>

    <v-toolbar dark style="box-shadow: none; border-radius: 5px" dense>
      <v-toolbar-title class="text-h6 px-1">Preview</v-toolbar-title>

      <v-spacer />
      <div style="margin-right: -16px">
        <GIconBtn i18n="form.print" icon="mdi-printer" @click="print" />
        <GIconBtn
          i18n="dcc.preview.copyXml"
          icon="mdi-clipboard-outline"
          @click="copyXml"
        />
        <GIconBtn
          i18n="dcc.preview.savePdf"
          icon="mdi-file-pdf-box"
          @click="$emit('savePDF')"
        />
        <GIconBtn
          i18n="dcc.preview.saveXml"
          icon="mdi-content-save-outline"
          @click="$emit('save')"
        />
      </div>

      <template #extension>
        <v-tabs v-model="tab" align-with-title>
          <v-tabs-slider />

          <v-tab>Human Readable</v-tab>
          <v-tab>XML</v-tab>
          <v-tab>{{ $t("dcc.preview.files.title") }}</v-tab>
        </v-tabs>
      </template>
    </v-toolbar>

    <v-tabs-items
      v-model="tab"
      style="border: 1px solid lightgrey; border-radius: 5px; min-height: 90vh"
      class="mt-4"
    >
      <v-tab-item>
        <CircleLoader
          v-if="isValidDcc && previewLoading"
          class="mx-auto d-block"
          color="primary"
        />

        <v-alert
          v-show="!isValidDcc"
          class="mt-5"
          color="error"
          icon="error"
          outlined
        >
          {{ $t("tool.invalidDccWarning") }}
        </v-alert>

        <iframe
          v-show="isValidDcc && !previewLoading"
          ref="preview"
          class="hidden-print-only"
          style="width: 100%; border: 0px"
          aria-label="Human Readable"
          @load="frameLoaded"
        />
      </v-tab-item>
      <v-tab-item>
        <client-only>
          <GCodeEditor v-model="xml" lang="xml" read-only />
        </client-only>
      </v-tab-item>
      <v-tab-item class="px-4">
        <GCheckbox
          v-model="documentOccupied"
          :disabled="documentOccupiedWithExternal"
          i18n="dcc.preview.attachHR"
        />
        <v-alert v-if="documentOccupiedWithExternal" type="info" outlined>
          {{ $t("tool.documentOccupiedWithExternal") }}
        </v-alert>
        <GFileList
          v-for="(item, index) in dccFiles"
          :key="index"
          v-model="item.files"
          :title="item.i18n"
        />
      </v-tab-item>
    </v-tabs-items>
  </div>
</template>

<script>
import { timeout } from "assets/util/general";
import GCodeEditor from "~/components/App/Common/GCodeEditor";
import { copyToClipboard } from "~/assets/util/clipboard";
import CircleLoader from "@/components/App/Util/CircleLoader";
import GCheckbox from "@/components/App/Form/gCheckbox";
import GFileList from "@/components/App/Common/GFileList";
import GIconBtn from "~/components/App/Common/GIconBtn.vue";

export default {
  name: "DccPreview",
  components: { GIconBtn, GFileList, GCheckbox, CircleLoader, GCodeEditor },
  props: {
    isValidDcc: Boolean,
  },
  data() {
    return {
      dccDocument: null,
      previewLoading: true,
      tab: null,
      loadNewDCC: false,
    };
  },
  computed: {
    xml() {
      return this.dccDocument?.toXML() ?? "";
    },
    isToolHR() {
      return (
        this.dccDocument?.digitalCalibrationCertificate.document?.fileName
          ._text === "human_readable.html"
      );
    },
    documentOccupied: {
      get() {
        return this.dccDocument?.digitalCalibrationCertificate.document;
      },
      set(val) {
        this.toggleHR(val);
      },
    },
    documentOccupiedWithExternal() {
      return this.documentOccupied && !this.isToolHR;
    },
    dccFiles() {
      const domParser = new DOMParser();
      let xmlDom = domParser.parseFromString(this.xml, "text/xml");
      // render File Preview page
      xmlDom = xmlDom.children[0].children;
      const dccFiles = {
        administrativeData: {
          i18n: "tool.navigation.step.administrativeData",
          files: [],
        },
        measurementResults: {
          i18n: "tool.navigation.step.measurementResults",
          files: [],
        },
        comments: {
          i18n: "tool.navigation.step.comments",
          files: [],
        },
        document: {
          i18n: "tool.navigation.step.document",
          files: [],
        },
      };
      for (let i = 0; i < xmlDom.length; i++) {
        const file = xmlDom[i].getElementsByTagName("dcc:fileName");
        const ringName = xmlDom[i].nodeName.replace("dcc:", "");
        for (let j = 0; j < file.length; j++) {
          dccFiles[ringName].files.push({
            fileName: file[j].innerHTML,
            mimeType: file[j].nextElementSibling.innerHTML,
            dataBase64: file[j].nextElementSibling.nextElementSibling.innerHTML,
          });
        }
      }
      return dccFiles;
    },
  },
  mounted() {
    this.$global.$on("updatePreview", this.updatePreview);
  },
  beforeDestroy() {
    this.$global.$off("updatePreview", this.updatePreview);
  },
  methods: {
    toggleHR(includeHR) {
      this.$emit("updateHR", includeHR);
    },
    async updatePreview(dccDocument) {
      this.previewLoading = true;
      this.$set(this, "dccDocument", dccDocument);

      // delay rendering of the preview, because otherwise the stepper tab switching animation lags
      await timeout(200);

      await this.renderPreview(dccDocument);
    },
    async renderPreview(dccDocument) {
      const result = await this.$tool.previewStrategy.renderPreview(
        dccDocument
      );

      this.$refs.preview.contentWindow.document.open();
      this.$refs.preview.contentWindow.document.write(result);
      this.$refs.preview.contentWindow.document.close();
    },
    async frameLoaded() {
      this.previewLoading = false;
      await this.$nextTick();
      // set height to the iframe to prevent scrollbars
      // add 50px for good measure
      this.$refs.preview.height = `${
        this.$refs.preview.contentWindow.document.body.scrollHeight + 50
      }px`;
    },
    print() {
      // printing does not work in ssr
      if (process.browser) {
        this.$refs.preview.contentWindow.print();
      }
    },
    async copyXml() {
      try {
        await copyToClipboard(this.xml);
        this.$notifier.success(this.$t("dcc.preview.copiedXmlSuccessfully"));
      } catch (e) {
        this.$notifier.error(this.$t("dcc.preview.copyError"));
      }
    },
  },
};
</script>
